DEUTSC 	ORG	0B000H
 INIT	LD	HL,(4004H)
 	LD	(RST10+1),HL
 	LD	HL,START1
 	LD	(4004H),HL
 	LD	HL,(4007H)
 	LD	(RST18+1),HL
 	LD	HL,START2
 	LD	(4007H),HL
 	LD	A,(41D0H)
 	LD	(PATCH5),A
 	LD	HL,(41D1H)
 	LD	(PATCH5+1),HL
 	LD	A,0C3H
 	LD	(41D0H),A
 	LD	HL,START3
 	LD	(41D1H),HL
 	LD	A,(41A6H)
 	LD	(PATCH9),A
 	LD	HL,(41A7H)
 	LD	(PATCH9+1),HL
 	LD	HL,START4
 	LD	A,0C3H
 	LD	(41A6H),A
 	LD	(41A7H),HL
 	LD	A,(41B2H)
 	LD	(PATCH),A
 	LD	HL,(41B3H)
 	LD	(PATCH+1),HL
 	LD	A,0C3H
 	LD	(41B2H),A
 	LD	HL,START5
 	LD	(41B3H),HL
 	XOR	A
 	LD	(FLAG),A
 	JP	6CCH
 FLAG	DEFB	0
 START1	LD	A,(FLAG)
 	OR	A
 	JR	Z,RST10
 	EX	(SP),HL
 	LD	A,82H
 	CP	L
 	JR	NZ,STARTY
 	LD	A,1AH
 	CP	H
 	JP	Z,INPUT
 STARTY	EX	(SP),HL
 RST10	JP	$-$
 INPUT	POP	HL
 	RST	10H
 	INC	A
 	DEC	A
 	JP	Z,1A33H
 	PUSH	AF
 	CALL	1E5AH
 BLANK	DEC	HL
 	LD	A,(HL)
 	CP	32
 	JR	Z,BLANK
 	INC	HL
 	LD	A,(HL)
 	CP	32
 	CALL	Z,9C9H
 	PUSH	DE
 	CALL	TOKEN
 	JP	1A9CH
 TOKEN	XOR	A
 	LD	(40B0H),A
 	LD	C,A
 	EX	DE,HL
 	LD	HL,(40A7H)
 	DEC	HL
 	DEC	HL
 	EX	DE,HL
 START	LD	A,(HL)
 	CP	32
 	JP	Z,BLANK1
 	LD	B,A
 	CP	'"'
 	JP	Z,APOS
 	OR	A
 	JP	Z,ENDE
 	LD	A,(40B0H)
 	OR	A
 	LD	A,(HL)
 	JP	NZ,BLANK1
 	CP	'?'
 	LD	A,0B2H		;PRINT TOKEN
 	JP	Z,BLANK1
 	LD	A,(HL)
 	CP	'0'
 	JR	C,CONTR
 	CP	'<'
 	JP	C,BLANK1
 CONTR	PUSH	DE
 	LD	DE,TAB1-1
 	PUSH	BC
 	LD	BC,CONT
 	PUSH	BC
 	LD	B,7FH
 	LD	A,(HL)
 	CP	61H
 	JR	C,UP
 	CP	7BH
 	JR	NC,UP
 	AND	5FH
 	LD	(HL),A
 UP	LD	C,(HL)
 	EX	DE,HL
 NTOK	INC	HL
 	OR	(HL)
 	JP	P,NTOK
 	INC	B
 	LD	A,(HL)
 	AND	7FH
 	RET	Z
 	CP	C
 	JR	NZ,NTOK
 	EX	DE,HL
 	PUSH	HL
 MATCH	INC	DE
 	LD	A,(DE)
 	OR	A
 	JP	M,TOK
 	LD	C,A
 	LD	A,B
 	CP	8DH
 	JR	NZ,NGOTO
 	RST	10H
 	DEC	HL
 NGOTO	INC	HL
 	LD	A,(HL)
 	CP	61H
 	JR	C,UPPER
 	AND	5FH
 UPPER	CP	C
 	JR	Z,MATCH
 	POP	HL
 	JR	UP
 TOK	LD	C,B
 	POP	AF
 	EX	DE,HL
 	RET
 CONT	EX	DE,HL
 	LD	A,C
 	POP	BC
 	POP	DE
 	EX	DE,HL
 	CP	95H
 	LD	(HL),3AH
 	JR	NZ,L1
 	INC	C
 	INC	HL
 L1	CP	0FBH
 	JR	NZ,L2
 	LD	(HL),3AH
 	INC	HL
 	LD	B,93H
 	LD	(HL),B
 	INC	HL
 	EX	DE,HL
 	INC	C
 	INC	C
 	JR	APOS
 L2	EX	DE,HL
 BLANK1	INC	HL
 	LD	(DE),A
 	INC	DE
 	INC	C
 	SUB	3AH
 	JR	Z,ENDSTM
 	CP	4EH
 	JR	NZ,NDATA
 ENDSTM	LD	(40B0H),A
 NDATA	SUB	59H
 	JP	NZ,START
 	LD	B,A
 NEXT	LD	A,(HL)
 	OR	A
 	JR	Z,ENDE
 	CP	B
 	JR	Z,BLANK1
 APOS	INC	HL
 	LD	(DE),A
 	INC	C
 	INC	DE
 	JR	NEXT
 ENDE	LD	HL,5
 	LD	B,H
 	ADD	HL,BC
 	LD	B,H
 	LD	C,L
 	LD	HL,(40A7H)
 	DEC	HL
 	DEC	HL
 	DEC	HL
 	LD	(DE),A
 	INC	DE
 	LD	(DE),A
 	INC	DE
 	LD	(DE),A
 	RET
 START2	LD	A,(FLAG)
 	OR	A
 	JP	Z,RST18
 	EX	(SP),HL
 	LD	A,H
 	CP	2BH
 	JP	NZ,RST19
 	LD	A,L
 	CP	53H
 	JP	Z,L99
 RST19	LD	A,H
 	CP	1AH
 	JP	NZ,RST20
 	LD	A,L
 	CP	6BH
 	JP	Z,AUTO
 RST20	LD	A,H
 	CP	1BH
 	JP	NZ,RST21
 	LD	A,L
 	CP	3DH
 	JP	Z,L9
 RST21	EX	(SP),HL
 RST18	JP	$-$
 L99	POP	HL
 	RST	18H
 	POP	BC
 	JP	C,1A18H
 	EX	(SP),HL
 	PUSH	HL
 	PUSH	BC
 	EX	DE,HL
 	LD	(40ECH),HL
 	CALL	0FAFH
 	LD	A,32
 	POP	HL
 	CALL	32AH
 	CALL	TEXT
 	JP	2B6AH
 L9	EX	(SP),HL
 	EXX
 	POP	DE
 	POP	HL
 	LD	A,H
 	CP	2EH
 	JP	Z,L10
 	PUSH	HL
 	PUSH	DE
 	EXX
 	JP	RST18
 L10	PUSH	HL
 	PUSH	DE
 	EXX
 	EX	(SP),HL
 	POP	HL
 	EX	(SP),HL
 	LD	HL,EDIT
 	EX	(SP),HL
 	RST	18H
 	LD	H,B
 	LD	L,C
 	LD	A,(HL)
 	INC	HL
 	LD	H,(HL)
 	LD	L,A
 	CCF
 	RET	Z
 	CCF
 	RET	NC
 	JP	1B2FH
 EDIT	JP	NC,1ED9H
 	LD	H,B
 	LD	L,C
 	INC	HL
 	INC	HL
 	LD	C,(HL)
 	INC	HL
 	LD	B,(HL)
 	INC	HL
 	PUSH	BC
 	CALL	TEXT
 	JP	2E7CH
 TEXT	PUSH	HL
 	LD	HL,(40A7H)
 	LD	B,H
 	LD	C,L
 	POP	HL
 	LD	D,255
 	JR	TEXT1
 NEXT1	INC	BC
 	DEC	D
 	RET	Z
 TEXT1	LD	A,(HL)
 	OR	A
 	INC	HL
 	LD	(BC),A
 	RET	Z
 	JP	P,NEXT1
 	CP	0FBH
 	JR	NZ,NREM
 	DEC	BC
 	DEC	BC
 	DEC	BC
 	DEC	BC
 	INC	D
 	INC	D
 	INC	D
 	INC	D
 NREM	CP	95H
 	CALL	Z,0B24H
 	SUB	7FH
 	PUSH	HL
 	LD	E,A
 	LD	HL,TAB1
 SEARCH	LD	A,(HL)
 	OR	A
 	INC	HL
 	JP	P,SEARCH
 	DEC	E
 	JR	NZ,SEARCH
 	AND	7FH
 	EX	AF,AF'
 	LD	A,32
 	LD	(BC),A
 	INC	BC
 	DEC	D
 	JP	Z,28D8H
 	EX	AF,AF'
 COPY1	LD	(BC),A
 	INC	BC
 	DEC	D
 	JP	Z,28D8H
 	LD	A,(HL)
 	INC	HL
 	OR	A
 	JP	P,COPY1
 	LD	A,32
 	LD	(BC),A
 	INC	BC
 	DEC	D
 	JP	Z,28D8H
 	POP	HL
 	JR	TEXT1
 START3	LD	A,(FLAG)
 	OR	A
 	JR	NZ,L56
 PATCH5	DEFS	3
 L56	EXX
 	POP	BC
 	POP	HL
 	LD	DE,2FE6H
 	RST	18H
 	JP	Z,INSERT
 	PUSH	HL
 	PUSH	BC
 	EXX
 	JR	PATCH5
 INSERT	EXX
 	XOR	A
 	POP	BC
 	POP	DE
 	LD	A,D
 	AND	E
 	INC	A
 	LD	HL,(40A7H)
 	DEC	HL
 	JR	Z,PATCH5
 	SCF
 	INC	HL
 	PUSH	AF
 	PUSH	DE
 	CALL	TOKEN
 	JP	1A9CH
 START4	LD	A,(FLAG)
 	OR	A
 	JR	NZ,L29
 	XOR	A
 PATCH9	DEFS	3
 L29	POP	HL
 	XOR	A
 	PUSH	AF
 	PUSH	BC
 	LD	B,0
 	LD	HL,TAB2
 	ADD	HL,BC
 	LD	A,(HL)
 	INC	HL
 	LD	H,(HL)
 	LD	L,A
 	POP	BC
 	POP	AF
 	JP	1A01H
 START5	PUSH	AF
 	PUSH	HL
 	LD	HL,(40A7H)
 	DEC	HL
 	DEC	HL
 	LD	IX,DEUT
 	LD	A,(HL)
 	CP	(IX)
 	JR	NZ,L21
 L20	INC	HL
 	INC	IX
 	LD	A,(IX)
 	OR	A
 	JP	Z,FERTIG
 	CP	(HL)
 	JP	NZ,PATCH1
 	JP	L20
 L21	LD	IX,ENG
 	LD	A,(IX)
 	CP	(HL)
 	JP	NZ,PATCH1
 	JP	L20
 PATCH1	POP	HL
 	POP	AF
 PATCH	DEFS	3
 FERTIG	LD	A,(IX-4)
 	CP	'I'
 	JP	NZ,DEUTS
 	XOR	A
 DEUTS	LD	(FLAG),A
 	POP	HL
 	POP	AF
 	JP	6CCH
 AUTO	POP	HL
 	RST	18H
 	POP	DE
 	JP	NC,1A5AH
 	LD	(40E2H),HL
 	OR	255
 	LD	HL,(40A7H)
 	DEC	HL
 	RET	Z
 	SCF
 	INC	HL
 	PUSH	AF
 	PUSH	DE
 	CALL	TOKEN
 	JP	1A9CH
 DEUT	DEFM	'DEUTSCH'
 	DEFB	0
 ENG	DEFM	'ENGLISCH'
 	DEFB	0
 TAB1	DEFB	'P'+80H
 	DEFM	'ROGRAMMENDE'
 	DEFB	'S'+80H
 	DEFM	'CHLEIFE VON'
 	DEFB	'S'+80H
 	DEFM	'ETZE ZURUECK'
 	DEFB	'S'+80H
 	DEFM	'ETZE'
 	DEFB	'L'+80H
 	DEFM	'OESCHE BILDSCHIRM'
 	DEFB	'B'+80H
 	DEFM	'EFEHL'
 	DEFB	'I'+80H
 	DEFM	'NITIALISIERE ZUFALLSGENERATOR'
 	DEFB	'N'+80H
 	DEFM	'AECHSTER WERT'
 	DEFB	'D'+80H
 	DEFM	'ATEN'
 	DEFB	'E'+80H
 	DEFM	'INGABE VON'
 	DEFB	'F'+80H
 	DEFM	'ELDGRENZEN'
 	DEFB	'L'+80H
 	DEFM	'ESE'
 	DEFB	'Z'+80H
 	DEFM	'UWEISUNG'
 	DEFB	'S'+80H
 	DEFM	'PRINGE NACH'
 	DEFB	'S'+80H
 	DEFM	'TARTE'
 	DEFB	'W'+80H
 	DEFM	'ENN'
 	DEFB	'N'+80H
 	DEFM	'EUE DATEN'
 	DEFB	'R'+80H
 	DEFM	'UFE UNTERPROGRAMM'
 	DEFB	'R'+80H
 	DEFM	'UECKKEHR'
 	DEFB	'A'+80H
 	DEFM	'NMERKUNG'
 	DEFB	'H'+80H
 	DEFM	'ALT'
 	DEFB	'S'+80H
 	DEFM	'ONST'
 	DEFB	'S'+80H
 	DEFM	'PURVERFOLGUNG EIN'
 	DEFB	'S'+80H
 	DEFM	'PURVERFOLGUNG AUS'
 	DEFB	'D'+80H
 	DEFM	'EFINIERE ZEICHENKETTE'
 	DEFB	'D'+80H
 	DEFM	'EFINIERE GANZZAHL'
 	DEFB	'D'+80H
 	DEFM	'EFINIERE EINFACHZAHL'
 	DEFB	'D'+80H
 	DEFM	'EFINIERE DOPPELTZAHL'
 	DEFB	'Z'+80H
 	DEFM	'EILEN'
 	DEFB	'A'+80H
 	DEFM	'ENDERE ZEILE'
 	DEFB	'G'+80H
 	DEFM	'ENERIERE FEHLER'
 	DEFB	'W'+80H
 	DEFM	'EITEREMACHEN BEI'
 	DEFB	'A'+80H
 	DEFM	'USGABE'
 	DEFB	'B'+80H
 	DEFM	'EI'
 	DEFB	'O'+80H
 	DEFM	'EFFNE'
 	DEFB	'U'+80H
 	DEFM	'NTERTEILE BUFFER'
 	DEFB	'H'+80H
 	DEFM	'OLE'
 	DEFB	'S'+80H
 	DEFM	'PEICHERE'
 	DEFB	'S'+80H
 	DEFM	'CHLIESSE'
 	DEFB	'L'+80H
 	DEFM	'ADE'
 	DEFB	'H'+80H
 	DEFM	'AENGE AN'
 	DEFB	'N'+80H
 	DEFM	'UMERIERE NEU'
 	DEFB	'L'+80H
 	DEFM	'OESCHE PROGRAMM'
 	DEFB	'L'+80H
 	DEFM	'INKS ANORDNEN'
 	DEFB	'R'+80H
 	DEFM	'ECHTS ANORDNEN'
 	DEFB	'S'+80H
 	DEFM	'PEICHERE AB'
 	DEFB	'M'+80H
 	DEFM	'ONITOR'
 	DEFB	'D'+80H
 	DEFM	'RUCKE AUS'
 	DEFB	'D'+80H
 	DEFM	'EFINIERE'
 	DEFB	'L'+80H
 	DEFM	'ADE SPEICHERZELLE'
 	DEFB	'G'+80H
 	DEFM	'EBE AUS'
 	DEFB	'F'+80H
 	DEFM	'AHRE FORT'
 	DEFB	'L'+80H
 	DEFM	'ISTE PROGRAMM'
 	DEFB	'D'+80H
 	DEFM	'RUCKE PROGRAMM'
 	DEFB	'L'+80H
 	DEFM	'OESCHE ZEILE'
 	DEFB	'A'+80H
 	DEFM	'UTOMATISCHE ZEILENNUMMERIERUNG'
 	DEFB	'I'+80H
 	DEFM	'NITIALISIERE'
 	DEFB	'L'+80H
 	DEFM	'ADE KASSETTENPROGRAMM'
 	DEFB	'S'+80H
 	DEFM	'PEICHERE KASSETTENPROGRAMM'
 	DEFB	'N'+80H
 	DEFM	'EUES PROGRAMM'
 	DEFB	'T'+80H
 	DEFM	'ABULAOR BEI('
 	DEFB	'B'+80H
 	DEFM	'IS'
 	DEFB	'F'+80H
 	DEFM	'UNKTION'
 	DEFB	'M'+80H
 	DEFM	'IT FORMAT'
 	DEFB	'A'+80H
 	DEFM	'DRESSE VON'
 	DEFB	'M'+80H
 	DEFM	'ASCHINENPROGRAMM'
 	DEFB	'F'+80H
 	DEFM	'EHLERZEILE'
 	DEFB	'F'+80H
 	DEFM	'EHLERCODE'
 	DEFB	'Z'+80H
 	DEFM	'EICHENKETTE'
 	DEFB	'U'+80H
 	DEFM	'NTERZEICHENKETTE'
 	DEFB	'A'+80H
 	DEFM	'BFRAGE'
 	DEFB	'Z'+80H
 	DEFM	'EIT'
 	DEFB	'F'+80H
 	DEFM	'REIER SPEICHERPLATZ'
 	DEFB	'G'+80H
 	DEFM	'EDRUECKTE TASTE'
 	DEFB	'D'+80H
 	DEFM	'ANN'
 	DEFB	'N'+80H
 	DEFM	'ICHT'
 	DEFB	'M'+80H
 	DEFM	'IT SCHRITTWEITE'
 	DEFB	'+'+80H
 	DEFB	'-'+80H
 	DEFB	'M'+80H
 	DEFM	'AL'
 	DEFB	'D'+80H
 	DEFM	'URCH'
 	DEFB	'H'+80H
 	DEFM	'OCH'
 	DEFB	'U'+80H
 	DEFM	'ND'
 	DEFB	'O'+80H
 	DEFM	'DER'
 	DEFB	'G'+80H
 	DEFM	'ROESSER'
 	DEFB	'G'+80H
 	DEFM	'LEICH'
 	DEFB	'K'+80H
 	DEFM	'LEINER'
 	DEFB	'V'+80H
 	DEFM	'ORZEICHEN VON'
 	DEFB	'G'+80H
 	DEFM	'AUSSFUNKTION VON'
 	DEFB	'A'+80H
 	DEFM	'BSOLUTWERT VON'
 	DEFB	'P'+80H
 	DEFM	'LATZ FUER'
 	DEFB	'E'+80H
 	DEFM	'INGABE VON'
 	DEFB	'K'+80H
 	DEFM	'URSORPOSITION'
 	DEFB	'W'+80H
 	DEFM	'URZEL AUS'
 	DEFB	'Z'+80H
 	DEFM	'UFALLSZAHL UNTER'
 	DEFB	'D'+80H
 	DEFM	'EKADISCHER LOGARITHMUS'
 	DEFB	'E'+80H
 	DEFM	' HOCH'
 	DEFB	'C'+80H
 	DEFM	'OSINUS'
 	DEFB	'S'+80H
 	DEFM	'INUS'
 	DEFB	'T'+80H
 	DEFM	'ANGENS'
 	DEFB	'A'+80H
 	DEFM	'RCUSTANGENS'
 	DEFB	'I'+80H
 	DEFM	'NHALT VON SPEICHERZELLE'
 	DEFB	'G'+80H
 	DEFM	'ANZZAHL AUS'
 	DEFB	'E'+80H
 	DEFM	'INFACHZAHL AUS'
 	DEFB	'D'+80H
 	DEFM	'OPPELTGENAUE ZAHL AUS'
 	DEFB	'F'+80H
 	DEFM	'ILEENDE'
 	DEFB	'P'+80H
 	DEFM	'OSITION'
 	DEFB	'L'+80H
 	DEFM	'ETZTE RECORDNUMMER'
 	DEFB	'G'+80H
 	DEFM	'ANZZAHLZEICHENKETTE AUS'
 	DEFB	'E'+80H
 	DEFM	'INFACHZAHLZEICHENKETTE AUS'
 	DEFB	'D'+80H
 	DEFM	'OPPELTZAHLZEICHENKETTE AUS'
 	DEFB	'G'+80H
 	DEFM	'ANZZAHL AUS'
 	DEFB	'E'+80H
 	DEFM	'INFACHZAHL VON'
 	DEFB	'D'+80H
 	DEFM	'OPPELTZAHL VON'
 	DEFB	'V'+80H
 	DEFM	'ORKOMMAZAHL VON'
 	DEFB	'Z'+80H
 	DEFM	'EICHENKETTENLAENGE VON'
 	DEFB	'Z'+80H
 	DEFM	'EICHENKETTENWANDLUNG VON'
 	DEFB	'Z'+80H
 	DEFM	'AHLENWERT VON'
 	DEFB	'A'+80H
 	DEFM	'SCIIWERT VON'
 	DEFB	'A'+80H
 	DEFM	'SCIIZEICHEN VON'
 	DEFB	'L'+80H
 	DEFM	'INKER TEIL DER ZEICHENKETTE'
 	DEFB	'R'+80H
 	DEFM	'ECHTER TEIL DER ZEICHENKETTE'
 	DEFB	'M'+80H
 	DEFM	'ITTLERER TEIL DER ZEICHENKETTE'
 	DEFB	80H
 TAB2	DEFW	NF
 	DEFW	SN
 	DEFW	RG
 	DEFW	OD
 	DEFW	FC
 	DEFW	OV
 	DEFW	OM
 	DEFW	UL
 	DEFW	BS
 	DEFW	DD
 	DEFW	NU
 	DEFW	ID
 	DEFW	TM
 	DEFW	OS
 	DEFW	LS
 	DEFW	ST
 	DEFW	CN
 	DEFW	NR
 	DEFW	UE
 	DEFW	UE
 	DEFW	MO
 	DEFW	FD
 	DEFW	L3
 NF	DEFM	'SCHLEIFENANFANG FEHLT'
 	DEFB	0
 SN	DEFM	'SCHREIBFEHLER'
 	DEFB	0
 RG	DEFM	'RUECKKEHR AUS NICHT VORHANDENEM UNTERPROGRAMM'
 	DEFB	0
 OD	DEFM	'MIR SIND DIE DATEN AUSGEGANGEN'
 	DEFB	0
 FC	DEFM	'FALSCHER ZAHLENWERT IM ARGUMENT'
 	DEFB	0
 OV	DEFM	'ZAHLENWERT ZU GROSS'
 	DEFB	0
 OM	DEFM	'MIR IST DER SPEICHERPLATZ AUSGEGANGEN'
 	DEFB	0
 UL	DEFM	'ZEILE NICHT VORHANDEN'
 	DEFB	0
 BS	DEFM	'FELDINDEX ZU GROSS'
 	DEFB	0
 DD	DEFM	'FELD ZUM ZWEITENMAL DEFINIERT IN'
 	DEFB	0
 NU	DEFM	'DIVISION DURCH NULL'
 	DEFB	0
 ID	DEFM	'NICHT ERLAUBT'
 	DEFB	0
 TM	DEFM	'FALSCHER VARIABLENTYP'
 	DEFB	0
 OS	DEFM	'ZEICHENKETTENPLATZ ZU KLEIN GEWORDEN'
 	DEFB	0
 LS	DEFM	'ZEICHENKETTE LAENGER ALS 255 ZEICHEN'
 	DEFB	0
 ST	DEFM	'ZEICHENKETTENAUSDRUCK ZU KOMPLIZIERT'
 	DEFB	0
 CN	DEFM	'WIEDERAUFNAHME DES PROGRAMMS NICHT MOEGLICH'
 	DEFB	0
 NR	DEFM	'KEINE RUECKKEHR VON DER FEHLERBEHANDLUNG'
 	DEFB	0
 UE	DEFM	'WIE HABEN SIE DAS GESCHAFFT'
 	DEFB	0
 MO	DEFM	'OPERAND FEHLT'
 	DEFB	0
 FD	DEFM	'KASSETTENLESEFEHLER'
 	DEFB	0
 L3	DEFM	'HAETTEN SIE WOHL GERNE'
 	DEFB	0
 	END	INIT
