DOS    	ORG	4200H
 	LD	HL,6D2H
 	LD	DE,4000H
 	LD	BC,36H
 	LDIR
 	CALL	LESEN
 	LD	HL,4400H
 	LD	DE,4300H
 	LD	BC,100H
 	LDIR
 	JP	4300H
 LESEN	LD	HL,37ECH
 	LD	A,1
 	LD	(37E1H),A
 	LD	A,(TRACK)
 	LD	D,A
 	LD	A,(SECTOR)
 	LD	E,A
 	LD	(37EEH),DE
 	LD	(HL),17H
 	LD	DE,BUFFER
 	LD	BC,37EFH
 	CALL	REST
 WAIT	BIT	0,(HL)
 	JR	NZ,WAIT
 	LD	(HL),88H
 	CALL	REST
 WAIT1	BIT	1,(HL)
 	JR	Z,WAIT1
 	LD	A,(BC)
 	LD	(DE),A
 	INC	E
 	JR	NZ,WAIT1
 	RET
 REST	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	EX	(SP),HL
 	RET
 OUTCH	EQU	33H
 INLINE	EQU	5D9H
 BUFFER	EQU	4400H
 TRACK	DEFB	0
 SECTOR	DEFB	1
 PROMPT	DEFM	'WELCHES PROGRAMM ?'
 	DEFB	14
 	DEFB	13
 	DEFB	255
 TEXT	DEFB	1CH
 	DEFB	1FH
 	DEFM	'DIES IST CARSTEN OTTO'
 	DEFB	39
 	DEFM	'S DOS'
 	DEFB	13
 	DEFB	255
 	ORG	4300H
 ANFANG	LD	HL,TEXT
 	CALL	AUSGAB
 	LD	A,0
 	LD	(TRACK),A
 	LD	A,2
 	LD	(SECTOR),A
 	CALL	ATTENT
 DIR	CALL	LESEN
 	LD	HL,4400H
 	CALL	AUSGAB
 	LD	HL,4480H
 	CALL	AUSGAB
 	CALL	NEXT
 	JR	C,DIR
 	CALL	ATTENT
 	LD	HL,PROMPT
 	CALL	AUSGAB
 	LD	B,63
 	LD	HL,BUFFER+256
 	CALL	INLINE
 	LD	A,B
 	CP	0
 	JR	Z,ANFANG
 	LD	A,2
 	LD	(SECTOR),A
 	LD	A,0
 	LD	(TRACK),A
 SEARCH	CALL	LESEN
 	CALL	COMPAR
 	JR	Z,EXEC
 	CALL	NEXT
 	JR	C,SEARCH
 	JR	ANFANG
 ATTENT	LD	A,(14400)
 	BIT	7,A
 	JR	Z,ATTENT
 	RET
 NEXT	LD	A,(SECTOR)
 	INC	A
 	CP	10
 	LD	(SECTOR),A
 	RET	C
 	LD	A,0
 	LD	(SECTOR),A
 	LD	A,(TRACK)
 	INC	A
 	LD	(TRACK),A
 	CP	40
 	CCF
 	RET
 AUSGAB	LD	A,(HL)
 	CP	255
 	RET	Z
 	CALL	OUTCH
 	INC	HL
 	JR	AUSGAB
 COMPAR	LD	HL,BUFFER
 	LD	DE,BUFFER+256
 LOOP1	LD	A,(DE)
 	CP	(HL)
 	JR	NZ,WEITER
 	CP	13
 	RET	Z
 	INC	HL
 	INC	DE
 	JR	LOOP1
 WEITER	BIT	7,L
 	RET	NZ
 	LD	HL,BUFFER+128
 	LD	E,0
 	JR	LOOP1
 EXEC	LD	BC,64
 	LD	A,L
 	AND	128
 	LD	L,A
 	ADD	HL,BC
 	PUSH	HL
 	POP	IX
 	LD	E,(IX)
 	LD	D,(IX+1)
 	LD	B,(IX+3)
 	LD	L,(IX+4)
 	LD	H,(IX+5)
 	LD	A,(IX+6)
 	LD	(TRACK),A
 	LD	A,(IX+7)
 	LD	(SECTOR),A
 LADEN	PUSH	AF
 	PUSH	BC
 	PUSH	HL
 	PUSH	DE
 	CALL	LESEN
 	POP	DE
 	LD	HL,BUFFER
 	LD	BC,256
 	LDIR
 	CALL	NEXT
 	POP	HL
 	POP	BC
 	POP	AF
 	DJNZ	LADEN
 	JP	(HL)
 	END
