TIMER  ;                 T I M E R
 ;             TRS-80  ALS WECKER
 ;
 ;(C) PETER WOLLSCHLAEGER         HILDESHEIM
 ;ELCOMP 7/8/82 SEITE 32
 	ORG	0F00H
 DSTART	CALL	INIT		;ENTRY VON DOS
 	JP	402DH
 BSTART	CALL	INIT		;ENTRY VON  BASIC
 	JP	06CCH
 ;
 INIT	LD	HL,(4016H)	;LINK -> KB-DCB
 	LD	(SAVE),HL
 	LD	(DRIVER+2),HL
 	LD	HL,DRIVER
 	LD	(4016H),HL
 	RET
 ;
 DRIVER	EXX			;RETTE REGISTER
 	CALL	$-$		;CHR -> A
 ;
 	CP	'W'+20H		;SHIFT W ?
 	JR	Z,STELLE
 ;
 	PUSH	AF
 	LD	A,(4043H)	;UHR STUNDE
 	LD	B,A
 	LD	A,(STUNDE)	;WECK-STUNDE
 	CP	B
 	JR	NZ,BACK
 	LD	A,(4042H)	;UHR-MINUTE
 	LD	B,A
 	LD	A,(MINUTE)	;WECK-MINUTE
 	CP	B		;GLEICH ?
 	JR	Z,WECKE
 BACK	POP	AF		;UNGLEICH
 	EXX
 	RET
 ;
 WECKE	LD	HL,ALARM	;TEXT ANZEIGEN
 	CALL	28A7H
 	LD	HL,(SAVE)	;WECKER ABSTELLEN
 	LD	(4016H),HL
 	LD	A,1
 	EXX
 	RET
 ;
 STELLE	LD	HL,ZEITH	;EINGABE WECKZEIT
 	CALL	ENTER
 	LD	(STUNDE),A
 	LD	HL,ZEITM
 	CALL	ENTER
 	LD	(MINUTE),A
 	LD	A,13
 	EXX
 	RET
 ENTER	CALL	28A7H		;DISP FRAGE
 	LD	HL,(40A7H)	;I/O-BUFFER
 	LD	B,2		;ERLAUBE 2 CHR
 	CALL	40H		;STRING-INPUT
 	JR	C,STELLE	;WENN BREAK
 	LD	HL,(40A7H)
 	CALL	1E5AH		;STRING ALS ZAHL ->  DE
 	LD	A,E
 	RET
 ;
 SAVE	DEFS	2
 MINUTE	DEFB	61		;DIE UNMOEGLICHE
 STUNDE	DEFB	25		;  UHRZEIT !
 ZEITH	DEFM	'WECKZEIT STUNDEN ? '
 	DEFB	0
 ZEITM	DEFM	'         MINUTEN ? '
 	DEFB	0
 ALARM	DEFB	0AH
 	DEFM	'***  DER WECKER KLINGELT  ***'
 	DEFB	0
 	END	DSTART
