UDK    ;********************  U D K  ***************************
 ;*               USER DEFINABLE KEYS                    *
 ;********************************************************
 ;
 ;DIESES PROGRAMM ERLAUBT DIE TRS-80-TASTATUR DOPPELT ZU
 ;NUTZEN. MIT AUSNAHME VON  @, #, $, *  KOENNEN UNTER
 ;ALLE TASTEN BELIEBIGE TEXTE INCL. BASIC-BEFEHLEN/ZEILEN
 ;GELEGT WERDEN. JEDER TEXT DARF MAX. 240 CHR. LANG SEIN,
 ;WENIGER SPART MEMORY.
 ;DER TEXTPUFFER WIRD AB PROGRAMMENDE RICHTUNG TOP OF MEM
 ;AUFGEBAUT.
 ;
 ;(C) PETER WOLLSCHLAEGER      HILDESHEIM 6/1981
 ;ELCOMP 11/12/81, SEITE 49
 ;********************************************************
 ;
 	ORG	0F000H		;ODER WO SIE WOLLEN.
 				;PROG. HAT 341 BYTES +
 				;TEXTPUFFER NACH WAHL
 ;
 ;--------------------------------------------------------
 ;IN KEYBOARD-DRIVER LINKEN:
 ;
 START	LD	HL,(4016H)	;ORIGINAL-KB -> OLDDRI
 	LD	(OLDDRI+1),HL
 	LD	HL,NEWDRI	;SPRUNGVEKTOR DES KB
 	LD	(4016H),HL	; MIT NEUER ADR. LADEN
 ;	LD	(5202H),HL	;** NUR BEI NEWDOS 2.1 **
 	JP	06CCH		;RET -> BASIC
 ;
 ;--------------------------------------------------------
 ;RETURN AN CALLER DES KB-DRIVERS EIN CHR. UDK-TEXT
 ;ANSTATT TASTENCODE:
 ;
 NEWDRI	LD	A,(FLAG)	;TESTE UDK-FLAG
 	OR	A
 	JR	Z,OLDDRI
 	LD	HL,(PTR)	;RET MIT BYTE (PTR)
 	LD	A,(HL)		; FALLS  NICHT
 	CP	13		;  TERMINATOR
 	JR	NZ,NOEND
 	XOR	A		;RESET UDK-FLAG
 	LD	(FLAG),A
 NOEND	INC	HL		;PTR -> NEXT UDK-BYTE
 	LD	(PTR),HL
 	RET			;MIT CHR. IN A
 ;--------------------------------------------------------
 ;TESTE, OB VIA SHIFT & SPACE UDK-MODE GEFORDERT:
 ;
 OLDDRI	CALL	$-$		;CALL KB-DRIVER
 	OR	A		;KEY AKTIV ?
 	RET	Z
 	LD	(AKKU),A	;RETTE KEY
 	LD	A,(3880H)	;SHIFT-KEY ?
 	CP	1
 	JR	NZ,BACK		;WENN NICHT SHIFT
 	LD	A,(3840H)	;SPACE-KEY ?
 	CP	80H
 	JR	Z,SELECT	;WENN SPACE & SHIFT
 BACK	LD	A,(AKKU)
 	RET
 ;------------------------------------
 ;TESTE WELCHE UDK-FUNKTION GEFORDERT:
 ;
 SELECT	LD	A,'*'		;DISP UDK-PROMPT
 	CALL	51
 	CALL	49H		;INPUT UDK-KEY
 	LD	(KEY),A
 	CP	'#'		;DISP TABELLENLAENGE ?
 	JR	Z,NUM
 	CP	'$'		;LISTING UDK-TEXTE ?
 	JR	Z,LIST
 	CP	'@'		;UDK-EINGABE GEWUENSCHT ?
 	JR	Z,STORE
 ;--------------------------------------------------------
 ;TEXT AUSGEBEN FALLS VORHANDEN:
 ;
 	LD	BC,(LANG)	;TABELLENLAENGE NOCH 0 ?
 	LD	A,B
 	OR	C
 	LD	A,' '
 	JR	Z,DELP		;DANN LOESCHE NUR DEN *
 	LD	HL,TABLE	;SUCHE KEY IN TABELLE
 	LD	A,(KEY)
 	SET	7,A
 	CPIR
 	LD	A,' '
 	JR	NZ,DELP		;* LOESCHEN
 	LD	A,(HL)		;1. CHR. DES TEXTES -> A
 	INC	HL		;(PTR) MIT ADRESSE DES
 	LD	(PTR),HL	; NAECHSTEN CHR. LADEN
 	LD	(FLAG),A	;SET UDK-FLAG <> 0
 DELP	LD	HL,(4020H)	;* LOESCHEN DURCH
 	DEC	HL		; DEKREMENT DER LFD.
 	LD	(4020H),HL	;  CURSORPOSITION
 	RET
 ;--------------------------------------------------------
 ;ANZEIGE AKTUELLE LAENGE DER TABELLE:
 ;
 NUM	LD	HL,(LANG)
 	CALL	0FAFH		;ROM: DISP (HL)
 	LD	A,13
 	RET
 ;--------------------------------------------------------
 ;ALLE UDK-TEXTE MIT IHREM KEY LISTEN:
 ;
 LIST	LD	HL,TABLE	;INIT
 	LD	BC,(LANG)
 	LD	A,13
 	CALL	51
 LOOP	LD	A,B		;LOOP BIS BC = 0
 	OR	C
 	RET	Z
 	LD	A,(HL)		;GET 1 CHR.
 	BIT	7,A		;IST ES KEY ?
 	JR	Z,NOKEY
 	RES	7,A		;DANN MACH ES LESBAR
 	CALL	51
 	LD	A,'='		;UND DISP NOCH EIN =
 NOKEY	CALL	51
 	INC	HL		;NEXT CHR.
 	DEC	BC
 ;-----------------------------------
 ;STOP/START LISTING AUF TASTENDRUCK:
 ;
 	CALL	2BH		;SCAN KEYBOARD
 	JR	Z,LOOP		;WENN KEINE TASTE AKTIV
 WAIT	CALL	2BH		;SONST WARTE BIS WIEDER
 	JR	Z,WAIT		; EINE TASTE AKTIV
 	JR	LOOP
 ;--------------------------------------------------------
 ;SPEICHERN, ERSETZEN ODER LOESCHEN EINES TEXTES:
 ;
 STORE	CALL	51		;DRUCKE NOCH DAS @
 	CALL	49H		;WARTE AUF EINGABE
 	LD	(KEY),A		;KEY RETTEN
 	CALL	51		; UND ANZEIGEN
 ;------------------------------------------
 ;WENN TAB-LAENGE NOCH 0 DIREKT ZUR EINGABE:
 ;
 	LD	BC,(LANG)
 	LD	A,B
 	OR	C
 	JR	Z,FREE
 ;---------------------
 ;TEST OB TASTE BELEGT:
 ;
 	LD	HL,TABLE
 	LD	A,(KEY)
 	SET	7,A
 	CPIR
 	LD	(PTR),HL	;RETTE TEXTBEGINN
 	JR	NZ,FREE
 ;------------------------------
 ;WENN BELEGT, FRAGE OB AENDERN:
 ;
 	LD	A,'?'		;DISP EIN ?
 	CALL	51
 	CALL	49H		;WARTE AUF INPUT
 	CP	13
 	JR	NZ,CHANGE	;WENN <> ENTER
 	XOR	A
 	RET
 ;------------------------------------
 ;DAS AENDERN GESCHIEHT, INDEM ERST
 ;DAS ALTE DURCH BLOCKTRANSFER UEBER-
 ;SCHRIEBEN UND DAS NEUE ANS ENDE DER
 ;GEKUERZTEN TABELLE GEHAENGT WIRD.
 ;------------------------------------
 ;SUCHE ENDE DES TEXTES:
 ;
 CHANGE	LD	HL,(PTR)	;TEXTBEGINN
 	LD	BC,240		;MOEGLICHE LAENGE
 	LD	A,13		;TERMINATOR
 	CPIR
 	PUSH	HL		;WIRD NOCH 2X GEBRAUCHT
 	PUSH	HL
 ;------------------------------------
 ;RECHNE BYTES TEXTENDE BIS TAB.-ENDE:
 ;
 	LD	HL,TABLE	;TAB.-ANFANG
 	LD	BC,(LANG)	;  + LAENGE
 	ADD	HL,BC		;    = TAB.-ENDE
 	POP	BC		;BC = TEXTENDE
 	PUSH	BC		;SP NICHT AENDERN
 	AND	A		;CLEAR CARRY
 	SBC	HL,BC		;TAB.-ENDE - TEXTENDE
 	INC	HL		;  + 1 = BYTES TO MOVE
 	PUSH	HL		;BC = HL
 	POP	BC
 ;---------------------
 ;UEBERSCHREIBE  'ALT':
 ;
 	LD	DE,(PTR)	;ZIEL = TEXTBEGINN
 	DEC	DE
 	POP	HL		;QUELLE = TEXTENDE
 	LDIR
 ;------------------------
 ;RECHNE NEUE TAB.-LAENGE:
 ;
 	POP	HL		;TEXTENDE
 	LD	BC,(PTR)	;TEXTANFANG
 	AND	A
 	SBC	HL,BC		;D.H.  HL = LAENGE DES
 	INC	HL		; GELOESCHTEN TEXTES
 	PUSH	HL		;BC = HL
 	POP	BC
 	LD	HL,(LANG)	;KORRIGIERE TAB.-LAENGE
 	AND	A
 	SBC	HL,BC
 	LD	(LANG),HL
 ;-------------------
 ;EINGABE NEUER TEXT:
 ;
 	LD	A,(KEY)		;DISP KEY UND :
 	CALL	51
 FREE	LD	A,':'
 	CALL	51
 	LD	HL,TABLE	;GEHE AUFS TAB.-ENDE
 	LD	BC,(LANG)
 	ADD	HL,BC
 	LD	A,(KEY)
 	SET	7,A		;MARKIERE KEY
 	LD	(HL),A
 	INC	HL
 	LD	B,240		;ERLAUBE MAX. 240 CHR.
 	CALL	5D9H		;ROM: LINEINPUT AB (HL)
 	JP	C,6CCH		;WENN BREAK VERGISS ALLES
 ;-----------------
 ;NEUE TAB.-LAENGE:
 ;
 	INC	B		;FUER DEN KEY
 	INC	B		; UND DIE 13 (CR)
 	LD	C,B		;BC = B
 	LD	B,0
 	LD	HL,(LANG)
 	ADD	HL,BC
 	LD	(LANG),HL
 	RET
 ;
 AKKU	DEFS	1
 FLAG	DEFB	0
 PTR	DEFS	2
 KEY	DEFS	1
 LANG	DEFW	0
 TABLE	EQU	$
 ;
 	END	START		;AUTOSTART
