XEDIT  ;                      XEDIT
 ;         EXTENDED EDITOR FUER TRS-80 U.A
 ;         UNTER   LEVEL 2, TRSDOS, NEWDOS
 ;
 ;(C) PETER WOLLSCHLAEGER        HILDESHEIM, 24.10.81
 ;ELCOMP 4/82 SEITE 9
 ;
 	ORG	0FE7CH		;FUER 16 K: 7E7C
 ;KEYBOARD-DCB MODIFIZIEREN
 ;-------------------------
 INIT	LD	HL,(4016H)
 	LD	(DRIVER+1),HL
 	LD	HL,DRIVER
 	LD	(4016H),HL
 	LD	HL,ONMSG	;PRINT 'XEDIT ON'
 	CALL	2B75H
 	JP	6CCH		;RETURN TO BASIC
 ;
 ;SCAN KEYBOARD, RETURN WENN PASSIV
 ;---------------------------------
 DRIVER	CALL	$-$
 	OR	A
 	RET	Z
 ;
 ;GET BUFFER POINTER FROM STACK
 ;-----------------------------
 	LD	(ASAVE),A
 	POP	AF
 	POP	BC
 	POP	DE
 	POP	HL
 	LD	(HSAVE),HL
 	PUSH	HL
 	PUSH	DE
 	PUSH	BC
 	PUSH	AF
 ;
 ;TESTE BUFFER POINTER, RETURN WENN >BEGINN
 ;-----------------------------------------
 	LD	HL,(HSAVE)	;BUFFERPOINTER
 	LD	DE,(40A7H)	;START OF BUFFER
 	RST	18H		;HL-DE
 	LD	A,(ASAVE)
 	RET	NZ
 ;
 ;TESTE OB ON/OFF GEFORDERT, WENN JA SWITCH
 ;-----------------------------------------
 	CP	'*'		;ON/OFF GEFORDERT?
 	LD	A,(ONOFF)	;ON=1, OFF=0
 	JR	NZ,GO		;WENN KEIN '*' -> GO
 	XOR	1		;SCHALTE UM
 	LD	(ONOFF),A	;  UND SAVE
 	LD	HL,OFFMSG	;MELDUNG 'XEDIT OFF'
 	JR	Z,PRINT		;PRINT IF OFF
 	LD	HL,ONMSG	;ELSE 'XEDIT ON'
 PRINT	CALL	2B75H		;PRINT TEXT (HL)
 	JP	6CCH		;READY
 GO	OR	A		;TESTE ON/OFF-SCHALTER
 	LD	A,(ASAVE)	;GET ORIG. CHR.
 	RET	Z		;RET IF OFF
 ;
 ;TESTE AUF XEDIT-ZEICHEN, RETURN WENN KEINES
 ;-------------------------------------------
 	CP	27		;SHIFT PFEIL OBEN
 	JR	Z,FIRST
 	CP	26		;SHIFT PFEIL UNTEN
 	JR	Z,LAST
 	CP	10		;PFEIL OBEN
 	JR	Z,FORWRD
 	CP	91		;PFEIL UNTEN
 	JR	Z,BCKWRD
 	CP	9		;PFEIL RECHTS
 	JR	Z,FASTF
 	CP	8		;PFEIL LINKS
 	JR	Z,FASTB
 	CP	'.'		;SYMBOLS CURRENT LINE
 	JR	Z,EDIT
 	CP	','		;SYMBOLS NEXT LINE
 	JR	Z,NEDIT
 	CP	'/'		;SYMBOLS STOP/ERROR LINE
 	JR	Z,LASTEX
 	CP	'='		;SYMBOLS COPY/EXECUTE
 	JP	Z,COPY
 	RET
 ;
 ;LISTE 1. ZEILE
 ;--------------
 FIRST	CALL	EMPTY		;EXIT IF NO PROGRAM
 	LD	HL,(40A4H)	;BASIC HEAD POINTER
 	JR	LDISP		;LIST ZEILE
 ;
 ;LISTE  LETZTE ZEILE
 ;-------------------
 LAST	CALL	EMPTY
 	LD	HL,(40F9H)	;BASIC TAIL POINTER
 	DEC	HL		;HL -> POINTER DER
 	DEC	HL		;  LETZTEN ZEILE
 SEARCH	LD	D,H		;DE = HL
 	LD	E,L
 	LD	A,H		;MSB
 	LD	BC,0
 LOOP	CPDR			;SUCHE MSB
 	LD	A,E
 	CP	(HL)		;PASST LSB ?
 	LD	A,D
 	JR	NZ,LOOP		;WENN NICHT
 	JR	LDISP		;GEFUNDEN, ALSO LIST
 ;
 ;LISTE NAECHSTE ZEILE
 ;--------------------
 FORWRD	LD	DE,(40ECH)	;GET CURRENT LINE #
 	INC	DE
 	CALL	1B2CH		;SEARCH LINE
 	JR	C,OK
 	JP	Z,1ED9H		;UL ERROR
 OK	PUSH	BC		;HL = BC
 	POP	HL
 	JR	LDISP
 ;
 ;LISTE ZEILE VORHER
 ;------------------
 BCKWRD	LD	DE,(40ECH)	;GET CURRENT LINE #
 	CALL	1B2CH		;SEARCH LINE
 	PUSH	BC		;HL = BC
 	POP	HL
 	PUSH	HL
 	LD	DE,(40A4H)	;TESTE OB PROG.-ANFANG
 	RST	18H
 	POP	HL
 	JP	Z,1ED9H		;IF SO, UL ERROR
 	JR	SEARCH		;SONST SUCHE VORGAENGER
 ;
 ;EDIT AKTUELLE ZEILE
 ;-------------------
 EDIT	LD	HL,(40ECH)	;GET CURRENT LINE #
 	JP	2E69H		;JUMP -> EDITOR
 ;
 ;EDIT FOLGEZEILE
 ;---------------
 NEDIT	LD	DE,(40ECH)	;GET CURRENT LINE #
 	CALL	1B2CH		;SUCHE ZEILE IM RAM
 	INC	HL
 	INC	HL
 	CALL	LOAD		;LD HL,(HL)
 	JP	C,2E69H		;IF CY THEN HL=NEXT LINE
 	JP	1ED9H		;ELSE UL ERROR
 ;
 ;EDIT STOP/ERROR-ZEILE
 ;---------------------
 LASTEX	LD	HL,(40F5H)	;LAST LINE EXECUTED
 	JP	2E69H		;JUMP -> EDITOR
 ;
 ;SCROLL LISTING VORWAERTS/RUECKWAERTS
 ;------------------------------------
 FASTF	LD	HL,FORWRD	;MODIFIZIERE CALL-ADRESSE
 	JR	MODIFY
 FASTB	LD	HL,BCKWRD
 MODIFY	LD	(LIST+1),HL
 LIST	CALL	$-$		;CALL FORWRD OR BCKWRD
 	LD	A,(3840H)	;PASSENDE KB-ZEILE
 	OR	A		;TASTE NOCH AKTIV ?
 	RET	Z		;WENN NICHT
 	JR	LIST
 ;
 ;TEST OB PROGRAMM DA
 ;-------------------
 EMPTY	LD	HL,(40A4H)	;BASIC HEAD POINTER
 	CALL	LOAD		;LD HL,(HL)
 	OR	H		;LEER ?
 	RET	NZ		;WENN NICHT
 	JP	1ED9H		;ELSE UL ERROR
 ;
 ;LIST 1 ZEILE
 ;------------
 LDISP	INC	HL		;BUMP POINTER
 	INC	HL
 	PUSH	HL
 	CALL	LOAD		;LD HL,(HL)
 	LD	(40ECH),HL	;CURRENT LINE #
 	CALL	0FAFH		;PRINT IT
 	LD	A,' '
 	CALL	51		;PRINT BLANK
 	POP	HL
 	INC	HL		;BUMP LINE #
 	INC	HL
 	CALL	2B7EH		;'ENTTOKE TEXT'
 	LD	HL,(40A7H)
 	CALL	2B75H		;PRINT TEXT
 	LD	A,13
 	CALL	51		;PRINT CR
 	XOR	A
 	RET
 ;
 ;COPY OR EXECUTE LINE
 ;--------------------
 COPY	LD	DE,(40ECH)	;GET CURRENT LINE #
 	CALL	1B2CH		;SUCHE ZEILE
 	INC	BC
 	INC	BC
 	INC	BC
 	INC	BC		;BC ZEIGT AUF TEXT
 	PUSH	BC
 	EX	DE,HL		;LINE # -> HL
 	CALL	0FAFH		;PRINT LINE #
 	LD	A,'='
 	CALL	51		;PRINT '='
 	LD	HL,(40A7H)	;START I/O-BUFFER
 	LD	B,5
 	CALL	40H		;INPUT NEUE ZEILEN #
 	JP	C,6CCH		;IF BREAK
 	LD	C,B
 	LD	B,0		;BC = LAENGE NEUE #
 	ADD	HL,BC		;ADD AUF POINTER
 	EX	DE,HL		;DE = DESTINATION
 	POP	HL		;HL = SOURCE
 	XOR	A
 TRANSF	CP	(HL)		;TRANSFER TEXT BIS 0-BYTE
 	LDI
 	JR	NZ,TRANSF
 	LD	HL,(40A7H)
 	DEC	HL
 	JP	1A81H		;PLAZIERE ZEILE
 ;
 ;LD HL,(HL)
 ;----------
 LOAD	LD	A,(HL)
 	INC	HL
 	LD	H,(HL)
 	LD	L,A
 	RET
 ;
 ;TEXTE UND WSB
 ;-------------
 ONMSG	DEFB	10
 	DEFM	'XEDIT ON'
 	DEFB	0
 OFFMSG	DEFB	10
 	DEFM	'XEDIT OFF'
 	DEFB	0
 ONOFF	DEFB	1
 ASAVE	DEFS	1
 HSAVE	DEFS	2
 RAM	EQU	$
 	END	INIT
